%define         sope_soname            4_9
%define         sope_version           4.9
%define         gs_makefiles           %_libdir/GNUstep/Makefiles
%define         sbjson_version         3.2.8
%define         oname SOPE

Name:           sope
Summary:        SKYRiX Object Publishing Environment
Version:        3.2.8
Release:        %mkrel 1
License:        GPLv2+
Group:          System/Libraries
Url:            http://www.sogo.nu
Source:         http://www.sogo.nu/files/downloads/SOGo/Sources/%{oname}-%{version}.tar.gz
Patch0:         SOPE-2.2.14-fix-link.patch
BuildRequires:  gcc-objc
BuildRequires:  gnustep-base-devel
BuildRequires:  mysql-devel
BuildRequires:  libxml2-devel
BuildRequires:  openldap-devel
BuildRequires:  openssl-devel
BuildRequires:  pkgconfig
BuildRequires:  postgresql-devel
BuildRequires:  sqlite3-devel
BuildRequires:  fdupes
BuildRequires:  gnustep-base

%description
SOPE is a framework for developing web applications and services. The
name "SOPE" (SKYRiX Object Publishing Environment) is inspired by ZOPE.

%package devel
Summary:        Development files for the SOPE libraries
Group:          Development/C#
Requires:       libGDLAccess%{sope_soname} = %{version}
Requires:       libNGLdap%{sope_soname} = %{version}
Requires:       libNGMime%{sope_soname} = %{version}
Requires:       libSBJson2 = %{sbjson_version}
Requires:       %{name}-appserver = %{version}
Requires:       %{name}-core = %{version}
Requires:       %{name}-xml = %{version}
Requires:       gnustep-make
Requires:       mysql-devel
Requires:       libxml2-devel
Requires:       openldap-devel
Requires:       postgresql-devel
Requires:       pkgconfig
Requires:       sqlite3-devel

%description devel
This package contains the development files of the SOPE libraries.


%package appserver
Summary:        SOPE application server libraries
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml

%description appserver
The SOPE application server libraries provide:

  * template rendering engine, lots of dynamic elements
  * HTTP client/server
  * XML-RPC client
  * WebDAV server framework
  * session management
  * scripting extensions for Foundation, JavaScript bridge
  * DOM tree rendering library

%package core
Summary:        Core libraries of the SOPE application server
Group:          System/Libraries
Requires:       %{name}-xml

%description core
The SOPE core libraries contain:

  * various Foundation extensions
  * a java.io like stream and socket library

%package xml
Summary:        SOPE libraries for XML processing
Group:          System/Libraries

%description xml
The SOPE libraries for XML processing contain:

  * a SAX2 Implementation for Objective-C
  * an attempt to implement DOM on top of SaxObjC
  * an XML-RPC implementation (without a transport layer)

%package -n libGDLAccess%{sope_soname}
Summary:        GNUstep database libraries for SOPE
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml

%description -n libGDLAccess%{sope_soname}
This package contains a fork of the GNUstep database libraries used
by the SOPE application server.

%package -n libNGLdap%{sope_soname}
Summary:        SOPE libraries for LDAP access
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml
Requires:       openldap

%description -n libNGLdap%{sope_soname}
The SOPE libraries for LDAP access contain an Objective-C wrapper for
LDAP directory services.

%package -n libNGMime%{sope_soname}
Summary:        SOPE libraries for MIME processing
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml

%description -n libNGMime%{sope_soname}
The SOPE libraries for MIME processing contain:

  * classes for processing MIME entities
  * a full IMAP4 implementation
  * prototypical POP3 and SMTP processor

%package -n libSBJson2
Summary:        JSON framework
Group:          System/Libraries
Version:        %{sbjson_version}
 
%description -n libSBJson2
The SBJson library is a high performance JSON library in Objective-C.
 
Project homepage is: http://code.google.com/p/json-framework/

%package gdl1-mysql
Summary:        MySQL connector for SOPE's fork of the GNUstep database environment
Group:          System/Libraries

%description gdl1-mysql
This package contains the MySQL connector for SOPE's fork of the
GNUstep database libraries.

%package gdl1-postgresql
Summary:        PostgreSQL connector for SOPE's fork of the GNUstep database environment
Group:          System/Libraries
%if %{?_postgresql_server_is_within_postgresql:1}%{!?_postgresql_server_is_within_postgresql:0}
Requires:       postgresql
%else
Requires:       postgresql-server
%endif

%description gdl1-postgresql
This package contains the PostgreSQL connector for SOPE's fork of the
GNUstep database libraries.

SOPE is a framework for developing web applications and services. The
name "SOPE" (SKYRiX Object Publishing Environment) is inspired by ZOPE.

%prep
%setup -q -n %name-%{oname}-%version
%autopatch -p1
# ****************************** build ********************************
%build
. %_libdir/GNUstep/Makefiles/GNUstep.sh

./configure --prefix=%{_prefix} \
  --disable-debug \
  --disable-strip \
  --gsmake=%_libdir/GNUstep/Makefiles

%make 

cd sope-gdl1/MySQL
%make

# ****************************** install ******************************
%install
install -d %{buildroot}%{_prefix}/lib

make DESTDIR=%{buildroot} \
  GNUSTEP_INSTALLATION_DOMAIN=SYSTEM \
  install

cd sope-gdl1/MySQL
make DESTDIR=%{buildroot} \
  GNUSTEP_INSTALLATION_DOMAIN=SYSTEM \
  install

rm -f %{buildroot}%{_bindir}/rss2plist1
rm -f %{buildroot}%{_bindir}/rss2plist2
rm -f %{buildroot}%{_bindir}/rssparse
rm -f %{buildroot}%{_bindir}/testqp
rm -fr %{buildroot}%{_prefix}/man/

%fdupes %{buildroot}%{_libdir}/sope-%{sope_version}

# ****************************** files ********************************
%files xml
%{_libdir}/libDOM*.so.%{sope_version}*
%{_libdir}/libSaxObjC*.so.%{sope_version}*
%{_libdir}/libXmlRpc*.so.%{sope_version}*
%dir %{_libdir}/sope-%{sope_version}/saxdrivers/
%dir %{_datadir}/sope-%{sope_version}/
%{_libdir}/sope-%{sope_version}/saxdrivers/libxmlSAXDriver.sax
%{_libdir}/sope-%{sope_version}/saxdrivers/STXSaxDriver.sax

%files core
%{_libdir}/libEOControl*.so.%{sope_version}*
%{_libdir}/libNGExtensions*.so.%{sope_version}*
%{_libdir}/libNGStreams*.so.%{sope_version}*
%dir %{_libdir}/sope-%{sope_version}/

%files appserver
%{_libdir}/libNGObjWeb*.so.%{sope_version}*
%{_libdir}/libWEExtensions*.so.%{sope_version}*
%{_libdir}/libWOExtensions*.so.%{sope_version}*
%dir %{_datadir}/sope-%{sope_version}/ngobjweb/
%{_datadir}/sope-%{sope_version}/ngobjweb/DAVPropMap.plist
%{_datadir}/sope-%{sope_version}/ngobjweb/Defaults.plist
%{_datadir}/sope-%{sope_version}/ngobjweb/Languages.plist
%dir %{_libdir}/sope-%{sope_version}/products/
%{_libdir}/sope-%{sope_version}/products/SoCore.sxp
%dir %{_libdir}/sope-%{sope_version}/wox-builders/
%{_libdir}/sope-%{sope_version}/wox-builders/WEExtensions.wox
%{_libdir}/sope-%{sope_version}/wox-builders/WOExtensions.wox

%files -n libGDLAccess%{sope_soname}
%{_bindir}/connect-EOAdaptor
%{_bindir}/load-EOAdaptor
%{_libdir}/libGDLAccess*.so.%{sope_version}*
%dir %{_libdir}/sope-%{sope_version}/dbadaptors/

%files -n libNGLdap%{sope_soname}
%{_libdir}/libNGLdap*.so.%{sope_version}*

%files -n libNGMime%{sope_soname}
%{_libdir}/libNGMime*.so.%{sope_version}*

%files -n libSBJson2
%{_libdir}/libSBJson.so.*

%files gdl1-mysql
%{_libdir}/sope-%{sope_version}/dbadaptors/MySQL.gdladaptor

%files gdl1-postgresql
%{_libdir}/sope-%{sope_version}/dbadaptors/PostgreSQL.gdladaptor

%files devel
# ***** appserver *****
%{_bindir}/wod
%{_includedir}/NGHttp
%{_includedir}/NGObjWeb
#%{_includedir}/NGXmlRpc
#%{_includedir}/SoOFS
%{_includedir}/WEExtensions
%{_includedir}/WOExtensions
#%{_includedir}/WOXML
%{_libdir}/libNGObjWeb*.so
#%{_libdir}/libNGXmlRpc*.so
#%{_libdir}/libSoOFS*.so
%{_libdir}/libWEExtensions*.so
#%{_libdir}/libWEPrototype*.so
%{_libdir}/libWOExtensions*.so
#%{_libdir}/libWOXML*.so
%{gs_makefiles}/Additional/ngobjweb.make
%{gs_makefiles}/woapp.make
%{gs_makefiles}/wobundle.make
# ***** core *****
%{_includedir}/EOControl
%{_includedir}/NGExtensions
%{_includedir}/NGStreams
%{_libdir}/libEOControl*.so
%{_libdir}/libNGExtensions*.so
%{_libdir}/libNGStreams*.so
# ***** xml *****
%{_includedir}/DOM
%{_includedir}/SaxObjC
%{_includedir}/XmlRpc
%{_libdir}/libDOM*.so
%{_libdir}/libSaxObjC*.so
%{_libdir}/libXmlRpc*.so
# ***** LibGDLAccess *****
%{_includedir}/GDLAccess
%{_libdir}/libGDLAccess*.so
# ***** LibNGLdaps *****
%{_includedir}/NGLdap
%{_libdir}/libNGLdap*.so
# ***** LibNGMime *****
%{_includedir}/NGImap4
%{_includedir}/NGMail
%{_includedir}/NGMime
%{_libdir}/libNGMime*.so
# ***** LibSNJson *****
%{_includedir}/SBJson
%{_libdir}/libSBJson.so





%changelog
* Wed Apr 26 2017 neoclust <neoclust> 3.2.8-1.mga6
+ Revision: 1097467
- New version - Fixes (CVE-2016-618[89], CVE-2016-619[01], CVE-2014-9905) (mga#18697)

* Thu Mar 03 2016 umeabot <umeabot> 2.3.1-5.mga6
+ Revision: 984122
- Rebuild for openssl

* Wed Feb 17 2016 umeabot <umeabot> 2.3.1-4.mga6
+ Revision: 962875
- Mageia 6 Mass Rebuild

* Mon Oct 26 2015 daviddavid <daviddavid> 2.3.1-3.mga6
+ Revision: 895567
- turn off stripping of debug symbols to fix empty debuginfo
- fix License

* Sun Aug 02 2015 neoclust <neoclust> 2.3.1-2.mga6
+ Revision: 860786
- New version 2.3.1

* Thu Jul 09 2015 neoclust <neoclust> 2.3.0-1.mga6
+ Revision: 853037
- New version
- imported package sope


* Mon Feb 02 2015 nlecureuil <nlecureuil> 2.2.15-5.mbs1
+ Revision: 146441
- New version

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-4.mbs2
+ Revision: 145969
- Fix build of json lib

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-3.mbs2
+ Revision: 145963
- Fix Requires

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-2.mbs2
+ Revision: 145959
- Fix Requires

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-1.mbs2
+ Revision: 145953
- imported package sope

